﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Http;
using System.Windows.Forms;

namespace PristaniNaMesici
{
    public partial class world : UserControl
    {
        private static readonly HttpClient client = new HttpClient();
        public string adresa;
        public bool mouse_control = false;

        int id = -1;
        double mx;
        double my;
        double sX;
        double sY;
        double palivo;
        double cil_x;
        double cil_x2;

        bool vlevo = false;
        bool vpravo = false;
        bool nahoru = false;

        public world()
        {
            InitializeComponent();
        }

        public async Task get_dataAsync()
        {
            tick.Enabled = false;
            string data;
            if (id == -1)
            {
                data = await client.GetStringAsync(adresa + "/start");
            }
            else
            {
                string content = adresa + "/stav?id=" + id.ToString();
                //Přídá parametry pro ovládání
                if (nahoru) { content += "&nahoru=1"; }
                else { content += "&nahoru=0"; }
                if (vpravo) { content += "&doprava=1"; }
                else { content += "&doprava=0"; }
                if (vlevo) { content += "&doleva=1"; }
                else { content += "&doleva=0"; }

                data = await client.GetStringAsync(content);
            }
            //Separuje víceřádkový řetězec do listu
            List<string> data2 = new List<string>(
                           data.Split(new string[] { "\r\n" },
                           StringSplitOptions.RemoveEmptyEntries));
            //Krach
            if(data2[0] == "Krach!")
            {
                tick.Enabled = false;
                MessageBox.Show("Krach!", "Prohra");
                FindForm().Close();
                return;
            }
            //Zdar
            if (data2[0] == "Zdar!")
            {
                tick.Enabled = false;
                MessageBox.Show("Zdar!", "Výhra");
                FindForm().Close();
                return;
            }
            //Načte do prom.
            id = Convert.ToInt32(data2[0]);
            //Pozice mod.
            var xy = data2[1].Replace(".", ",").Split(' ');
            mx = Convert.ToDouble(xy[0]);
            my = Convert.ToDouble(xy[1]);
            //Rychlost
            var sXsY = data2[2].Replace(".", ",").Split(' ');
            sX = Convert.ToDouble(xy[0]);
            sY = Convert.ToDouble(xy[1]);
            //Palivo
            palivo = Convert.ToDouble(data2[3].Replace(".", ","));
            //Cíl
            var cil_x_cil_y = data2[4].Replace(".", ",").Split(' ');
            cil_x = Convert.ToDouble(cil_x_cil_y[0]);
            cil_x2 = Convert.ToDouble(cil_x_cil_y[1]);

            Invalidate();
            tick.Enabled = true;
        }

        private void world_Paint(object sender, PaintEventArgs e)
        {
            //Modul
            e.Graphics.DrawImage(Properties.Resources.lunar_lander, 
                (float)mx - 10,
                Height - (float)my - 10,
                20, 
                20);
            //Plošina
            e.Graphics.DrawLine(Pens.Red,
                (float)(cil_x),
                Height - 1,
                (float)(cil_x2),
                Height - 1);
            //Palivo
            e.Graphics.DrawString("Palivo: " + palivo.ToString(),
                SystemFonts.DefaultFont,
                Brushes.Red,
                0, 0);

        }

        private async void tick_Tick(object sender, EventArgs e)
        {
            await get_dataAsync();
        }

        private void world_KeyDown(object sender, KeyEventArgs e)
        {
            if (!mouse_control)
            {
                switch (e.KeyCode)
                {
                    case Keys.W:
                        nahoru = true;
                        break;
                    case Keys.A:
                        vlevo = true;
                        break;
                    case Keys.D:
                        vpravo = true;
                        break;
                    default:
                        break;
                }
            }
        }

        private void world_KeyUp(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.W:
                    nahoru = false;
                    break;
                case Keys.A:
                    vlevo = false;
                    break;
                case Keys.D:
                    vpravo = false;
                    break;
                default:
                    break;
            }
        }

        private void world_MouseMove(object sender, MouseEventArgs e)
        {
            if (mouse_control)
            {
                if (e.X < Width / 2 - 30) { vlevo = true; } else { vlevo = false; }
                if (e.X > Width / 2 + 30) { vpravo = true; } else { vpravo = false; }
                if (e.Y < Height / 2) { nahoru = true; } else { nahoru = false; }
            }
        }
    }
}
